<template>
	<v-app>
		<v-main>
			<v-card>
				<v-card-text>
					<h3 class="d-flex justify-center my-5">
						isLastPage: {{ isLastPage }}, pageCount:
						{{ pageCount }}, typing: {{ typing }} , selected: {{selected}}, items: {{items.length}}
					</h3>
				</v-card-text>
			</v-card>
			<v-container>
				<v-row justify="center">
					<v-col cols="12" sm="9" class="mt-4">
						<v-autocomplete
							ref="autocomplete"
							v-model="selected"
							label="Type user firstname"
							:loading="loading"
							:items="items"
							:search-input.sync="search"
						>
							<template
								v-slot:append-item
                	v-if="typing === false"
							>
								<div
									v-if="!isLastPage && items.length !== 0"
									v-observe-visibility="{
										callback: visibilityChanged,
									}"
									class="text-center px-4 d-flex justify-center align-center py-2"
								>
									<h4 v-if="search.length < 3">Type user firstname to get results</h4>
                  <v-progress-circular
                    v-else
										indeterminate
										color="primary"
                    size="25"
									></v-progress-circular
									>
								</div>
							</template>
						</v-autocomplete>
					</v-col>
				</v-row>
			</v-container>
		</v-main>
	</v-app>
</template>

<script>
	import axios from "axios";
	export default {
		name: "app",
		data() {
			return {
				isLastPage: false,
				loading: false,
				items: [],
				selected: "",
				search: "",
				pageCount: 0,
				api: "http://localhost:5000",
				typing: true,
			};
		},

		watch: {
			search(val) {
        console.log('alo')
				if (val?.length >= 3) {
          console.log(val)
					this.pageCount = 0;
					this.isLastPage = false;
					this.typing = true;
					this.getItems();
				}else{
          this.items = [];
        }
			},
		},

		methods: {
			visibilityChanged(e) {
				if (e && this.search?.length >=3) this.getItems();
			},

			getItems() {
				if (this.isLastPage === true) return;
				console.log("getItems");
				this.loading = true;

				axios
					.get(
						`${this.api}/api/listItems/${this.search}/${this.pageCount}`
					)
					.then((res) => {
						this.items = [
							...this.items,
							...res.data.items.map((item) => ({
								text: `${item.firstName} ${item.lastName}`,
								value: item._id,
							})),
						];
						const { maxPageCount } = res.data;
						return maxPageCount;
					})
					.then((maxPageCount) => {
						// this.$refs.autocomplete.onScroll();
						this.pageCount = this.pageCount + 7;
						if (maxPageCount !== 0 && this.pageCount >= maxPageCount)
							this.isLastPage = true;
						this.typing = false;
					});
				this.loading = false;
			},
		},
	};
</script>
